public class Ricorsioni {
    
    public static double potenza(double x, int n) {
        //se n è negativo calcolo 1/(x^n)
        if(n<0)
            return 1/potenza(x,-n);
        
        //se n è nullo per impedire la potenza 0^0 devo restituire x/x, che vale 1 a patto che x sia diverso da zero!    
        if(n==0) 
            return x/x;
            
        //in tutti gli altri casi faccio il prodotto   x * x^(n-1)   
        return x*potenza(x, n-1);
    }
    
    public static int fattoriale(int n) {
        if(n==0)
            return 1;
        return n*fattoriale(n-1);
    }
}